$INCLUDE "RAPIDQ.INC"
$RESOURCE ICO_CARN AS "M:\CARNIVORES2\CARN2.ICO"

DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadMapFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture
DECLARE SUB DrawPicture3D
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB Proceed3D
DECLARE SUB Proceed0
DECLARE SUB Proceed1
DECLARE SUB Proceed2
DECLARE SUB Proceed3
DECLARE SUB Proceed4
DECLARE SUB Proceed5
DECLARE SUB Proceed6
DECLARE SUB Proceed7
DECLARE SUB Proceed8
DECLARE SUB Proceed9
DECLARE SUB Proceed10
DECLARE SUB Proceed11

DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)

DIM BitMap AS QBITMAP
    BitMap.Width = 2048
    BitMap.Height = 1536
    BitMap.Paint(0,0,0,0)    

DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM A?(1023,1023)
DIM B%(1023,1023)
DIM C%(1023,1023)
DIM D?(1023,1023)
DIM E%(1023,1023)
DIM F?(1023,1023)
DIM G?(1023,1023)
DIM H?(1023,1023)
DIM I?(1023,1023)
DIM J?(1023,1023)
DIM K?(511,511)
DIM L?(511,511)
DIM FileName$ as String
DIM Q AS SHORT
DIM Z AS SHORT
DIM YY AS SHORT
DIM ROJO AS BYTE
DIM VERDE AS BYTE
DIM AZUL AS BYTE

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, ExitPrg
     
DIM Surface3DMap AS QMenuItem
    Surface3DMap.Caption = "&3-D Surfaces"
    Surface3DMap.OnClick = Proceed3D

DIM SurfaceMap AS QMenuItem
    SurfaceMap.Caption = "&Surfaces"
    SurfaceMap.OnClick = Proceed0
    
DIM TextureMap1 AS QMenuItem
    TextureMap1.Caption = "Textures&1"
    TextureMap1.OnClick = Proceed1
    
DIM TextureMap2 AS QMenuItem
    TextureMap2.Caption = "Textures&2"
    TextureMap2.OnClick = Proceed2
        
DIM PlantsMap AS QMenuItem
    PlantsMap.Caption = "Ob&jects"
    PlantsMap.OnClick = Proceed3
    
DIM OrientationMap AS QMenuItem
    OrientationMap.Caption = "&Orientation"
    OrientationMap.OnClick = Proceed4
    
DIM ShadowMap1 AS QMenuItem
    ShadowMap1.Caption = "Da&wn Shadows"
    ShadowMap1.OnClick = Proceed5
    
DIM ShadowMap2 AS QMenuItem
    ShadowMap2.Caption = "Da&y Shadows"
    ShadowMap2.OnClick = Proceed6
    
DIM ShadowMap3 AS QMenuItem
    ShadowMap3.Caption = "Ni&ght Shadows"
    ShadowMap3.OnClick = Proceed7
    
DIM WaterMap AS QMenuItem
    WaterMap.Caption = "W&ater"
    WaterMap.OnClick = Proceed8
    
DIM ObjectsMap AS QMenuItem
    ObjectsMap.Caption = "S&tructures"
    ObjectsMap.OnClick = Proceed9
    
DIM FogMap AS QMenuItem
    FogMap.Caption = "&Fog"
    FogMap.OnClick = Proceed10
    
DIM SoundsMap AS QMenuItem
    SoundsMap.Caption = "So&unds"
    SoundsMap.OnClick = Proceed11
    
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.AddItems Surface3DMap, SurfaceMap, TextureMap1, TextureMap2, PlantsMap, OrientationMap, ShadowMap1, ShadowMap2, ShadowMap3, WaterMap, ObjectsMap, FogMap, SoundsMap
    ShowMenu.Enabled=False

CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 300
    Width = 450
    BorderStyle = 2
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu
END CREATE
CREATE Canvas AS QCanvas
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
    END CREATE
    Center
  ShowModal
END CREATE

SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
SELECT CASE Z
CASE 0
R = A?(Y, X)

CASE 1
R = B%(Y, X)

CASE 2
R = C%(Y, X)

CASE 3
R = D?(Y, X)

CASE 4
R = E%(Y, X)

CASE 5
R = F?(Y, X)

CASE 6
R = G?(Y, X)

CASE 7
R = H?(Y, X)

CASE 8
R = I?(Y, X)

CASE 9
R = J?(Y, X)

CASE 10
R = K?(Y/2, X/2)

CASE 11
R = L?(Y/2, X/2)

END SELECT
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)+":"+STR$(R)
END SUB      

SUB CanvasPaint
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)
    
    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.StretchDraw(RectArea, Bitmap.BMP)
END SUB

SUB FileOpen
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "MAP Files (*.map)|*.map|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
        Form1.Caption="Viewing "+FileName$
    LoadMapFile
'    ShowMenu.Enabled=True
      END IF
END SUB

     
SUB Proceed3D

Z=0
YY=0
InitScreen

END SUB

SUB Proceed0

Z=0
YY=1
InitScreen

END SUB

SUB Proceed1

Z=1
YY=1
InitScreen

END SUB

SUB Proceed2

Z=2
YY=1
InitScreen

END SUB

SUB Proceed3

Z=3
YY=1
InitScreen

END SUB

SUB Proceed4

Z=4
YY=1
InitScreen

END SUB

SUB Proceed5

Z=5
YY=1
InitScreen

END SUB

SUB Proceed6

Z=6
YY=1
InitScreen

END SUB

SUB Proceed7

Z=7
YY=1
InitScreen

END SUB

SUB Proceed8

Z=8
YY=1
InitScreen

END SUB

SUB Proceed9

Z=9
YY=1
InitScreen

END SUB

SUB Proceed10

Z=10
YY=1
InitScreen

END SUB

SUB Proceed11

Z=11
YY=1
InitScreen

END SUB


SUB ExitClick
  Form1.Close
END SUB  


SUB LoadMapFile

DIM File AS QFileStream
File.Open(FileName$, fnOpenRead)
IF File.Size=&HD80000 THEN
Form1.Caption="Reading Surface Data..."
Form1.Show
File.LoadArray(A?(0, 0),1024*1024)
Form1.Caption="Reading Textures Data..."
Form1.Show
File.LoadArray(B%(0, 0),1024*1024)
Form1.Caption="Reading More Textures Data..."
Form1.Show
File.LoadArray(C%(0, 0),1024*1024)
Form1.Caption="Reading Objects Data..."
Form1.Show
File.LoadArray(D?(0, 0),1024*1024)
Form1.Caption="Reading Orientation Data..."
Form1.Show
File.LoadArray(E%(0, 0),1024*1024)
Form1.Caption="Reading Dawn Shadows Data..."
Form1.Show
File.LoadArray(F?(0, 0),1024*1024)
Form1.Caption="Reading Day Shadows Data..."
Form1.Show
File.LoadArray(G?(0, 0),1024*1024)
Form1.Caption="Reading Night Shadows Data..."
Form1.Show
File.LoadArray(H?(0, 0),1024*1024)
Form1.Caption="Reading Water Data..."
Form1.Show
File.LoadArray(I?(0, 0),1024*1024)
Form1.Caption="Reading Structures Data..."
Form1.Show
File.LoadArray(J?(0, 0),1024*1024)
Form1.Caption="Reading Fog Data..."
Form1.Show
File.LoadArray(K?(0, 0),512*512)
Form1.Caption="Reading Sounds Data..."
Form1.Show
File.LoadArray(L?(0, 0),512*512)
Form1.Caption="Done"
Form1.Show
ShowMenu.Enabled=True
ELSE
Form1.Caption="Not a valid Carnivores 2/Ice Age .map file!"
Form1.Show
END IF    
File.Close

END SUB

SUB InitScreen

Canvas.Visible = False

'Form.ClientWidth = 2048
'Form.ClientHeight = 1536
'Form1.Width = 2048
'Form1.Height = 1536
'Form1.WindowState=2
'Form1AutoScroll = True

'Canvas.Parent = Form1
'Canvas.Font = Font
'Canvas.Color = 0
'Canvas.OnPaint = DrawPicture

Form1.Color = 0
Form1.Caption="Carnivores 2/Ice Age Map Viewer - "+FileName$+" - (C) 2003 by M.A.Ch.F."
'Form.Onresize = Resize

IF YY=0 THEN DrawPicture3D
IF YY=1 THEN DrawPicture
Form1.Center
Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True

END SUB


SUB DrawPicture

IF Z<10 THEN W=1024:S=1 ELSE W=512:S=2

Form1.ClientWidth = 1024
Form1.ClientHeight = 1024
Canvas.Width = 1024
Canvas.Height = 1024
Canvas.ClientWidth = 1024
Canvas.ClientHeight = 1024
BitMap.Width = W
BitMap.Height = W
BitMap.FillRect(0, 0, W, W, 0)

FOR X = 0 TO W-1
FOR Y = 0 TO W-1

SELECT CASE Z
CASE 0
R = A?(X, Y)
BITS = 1

CASE 1
R = B%(X, Y)
BITS = 1 '2

CASE 2
R = C%(X, Y)
BITS = 1 '2

CASE 3
R = D?(X, Y)
BITS = 1

CASE 4
R = E%(X, Y)
BITS = 2

CASE 5
R = F?(X, Y)
BITS = 0

CASE 6
R = G?(X, Y)
BITS = 0

CASE 7
R = H?(X, Y)
BITS = 0

CASE 8
R = I?(X, Y)
BITS = 1

CASE 9
R = J?(X, Y)
BITS = 1

CASE 10
R = K?(X, Y)
BITS = 1

CASE 11
R = L?(X, Y)
BITS = 1

END SELECT

SELECT CASE BITS

CASE 0

D=R

ROJO=D
VERDE=D
AZUL=D

D=(AZUL*&H10000+VERDE*&H100+ROJO)

CASE 1
D=&HFF0000
IF R<-40 THEN D=&HCC0000
IF R<-80 THEN D=&H990000
IF R<-120 THEN D=&H660000
IF R>0 THEN D=&H00CCFF
IF R>=40 THEN D=&H00CC00
IF R>=80 THEN D=&H009900
IF R>=120 THEN D=&H009966
IF R>=160 THEN D=&H006666
IF R>=200 THEN D=&HFFFFFF

AZUL=INT((D AND &HFF0000)/&H10000)
VERDE=(INT(D AND &H00FF00)/&H100)
ROJO=INT(D AND &H0000FF)

Q = R - 40*INT (R/40)

IF ROJO>Q THEN ROJO=ROJO-Q ELSE ROJO=0
IF VERDE>Q THEN VERDE=VERDE-Q ELSE VERDE=0
IF AZUL>Q THEN AZUL=AZUL-Q ELSE AZUL=0

D=(AZUL*&H10000+VERDE*&H100+ROJO)

CASE 2

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)


END SELECT

H = Y: V = X
H1 = Y + 1: V1 = X + 1
BitMap.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)

Form1.Caption="Row "+STR$(X)+", Col "+STR$(Y)
Form1.Show

NEXT Y: NEXT X


END SUB


SUB DrawPicture3D

W=1024:S=1

Form1.ClientWidth = 2048
Form1.ClientHeight = 1536
Canvas.Width = 2048
Canvas.Height = 1536
Canvas.ClientWidth = 2048
Canvas.ClientHeight = 1536
BitMap.Width = 2048
BitMap.Height = 1536
BitMap.FillRect(0, 0, 2048, 1536, 0)

K = .75
FOR X = 0 TO W-2
FOR Y = W-1 TO 1 STEP -1

R1 = A?(X, Y)/4: REM IF R1 < 0 THEN R1 = 0
R2 = A?(X, Y - 1)/4: REM IF R2 < 0 THEN R2 = 0
R3 = A?(X + 1, Y)/4: REM IF R3 < 0 THEN R3 = 0
R = A?(X + 1, Y - 1)/4: REM IF R < 0 THEN R = 0


R = (R + R1 + R2 + R3)
ANG = ABS( ATN( SQR( (R3 - R1)*(R3 - R1) + (R2 - R1)*(R2 - R1) ) ) )* 45/ATN(1)
IF ANG<0 THEN ANG=ANG+90

D=&HFF0000
IF R<-40 THEN D=&HCC0000
IF R<-80 THEN D=&H990000
IF R<-120 THEN D=&H660000
IF R>0 THEN D=&H00CCFF
IF R>=40 THEN D=&H00CC00
IF R>=80 THEN D=&H009900
IF R>=120 THEN D=&H009966
IF R>=160 THEN D=&H006666
IF R>=200 THEN D=&HFFFFFF

AZUL=INT((D AND &HFF0000)/&H10000)
VERDE=(INT(D AND &H00FF00)/&H100)
ROJO=INT(D AND &H0000FF)

Q=INT (ANG)

IF ROJO>Q THEN ROJO=ROJO-Q ELSE ROJO=0
IF VERDE>Q THEN VERDE=VERDE-Q ELSE VERDE=0
IF AZUL>Q THEN AZUL=AZUL-Q ELSE AZUL=0

D=(AZUL*&H10000+VERDE*&H100+ROJO)

H = X + Y: V = (Y - X) * K + R1
V=V*0.6
H1 = H - 1: V1 = 0.6 * ((Y - X - 1) * K + R2)
BitMap.FillRect(H1*S, 640 - V1*S, H*S, 640 - V*S , D)
H1 = H + 1: V1 = 0.6*((Y-X-1)*K+R3)
BitMap.FillRect(H*S, 640 - V*S, H1*S, 640 - V1*S, D)

Form1.Caption="Row "+STR$(X)+", Col "+STR$(Y)
Form1.Show

NEXT Y: NEXT X

END SUB


