$INCLUDE "RAPIDQ.INC"
$RESOURCE ICO_CARN AS "M:\CARNIVORES2\CARN2.ICO"
     
DECLARE SUB ChangeDirectories
DECLARE SUB ChangeDrive
DECLARE SUB LoadMapFile
DECLARE SUB InitScreen
DECLARE SUB DrawPicture555
DECLARE SUB ExitClick
DECLARE SUB FileOpen
DECLARE SUB StoreBitmap (Z AS INTEGER)

DECLARE SUB CanvasPaint
DECLARE SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
DECLARE SUB DrawTexture (Z AS INTEGER)
DECLARE SUB ShowTexture (Sender AS QMENUITEM)
DECLARE SUB ShowTexture1 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture2 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture3 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture4 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture5 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture6 (Sender AS QMENUITEM)
DECLARE SUB ShowTexture7 (Sender AS QMENUITEM)

DIM A1& AS INTEGER, B1& AS INTEGER, C1& AS INTEGER, D1& AS INTEGER, E1& AS INTEGER, F1& AS INTEGER, G1& AS INTEGER, H1& AS INTEGER
DIM I1& AS INTEGER, J1& AS INTEGER, K1& AS INTEGER, L1& AS INTEGER, M1& AS INTEGER, N1& AS INTEGER, O1& AS INTEGER, P1& AS INTEGER
DIM Q1& AS INTEGER, R1& AS INTEGER, S1& AS INTEGER, T1& AS INTEGER

DIM BitMap AS QBITMAP
    BitMap.Width = 128
    BitMap.Height = 128
    BitMap.Paint(0,0,0,0)    

DIM TextureList AS QBITMAP
    TextureList.Width = 128
    TextureList.Height = 128
    TextureList.Paint(0,0,0,0)    
    
DIM Font AS QFont
    Font.Name = "Arial"
    Font.Size = 12
    Font.Color = &H00FF00

DIM TEX??(127,127)
DIM FileName$ as String
DIM Q AS SHORT
DIM ROJO AS BYTE
DIM VERDE AS BYTE
DIM AZUL AS BYTE

DIM ChngDrv AS QMenuItem
    ChngDrv.Caption = "Change &Drive"
    ChngDrv.OnClick = ChangeDrive  

DIM OpenFile AS QMenuItem
    OpenFile.Caption = "&Open File"
    OpenFile.OnClick = FileOpen  

DIM ExitPrg AS QMenuItem
    ExitPrg.Caption = "E&xit"
    ExitPrg.OnClick = ExitClick
        
DIM FileMenu AS QMenuItem
    FileMenu.Caption = "&File"
    FileMenu.AddItems OpenFile, ExitPrg
 
DIM ShowMenu AS QMenuItem
    ShowMenu.Caption = "S&how"
    ShowMenu.Enabled=False

DIM MoreMenu1 AS QMenuItem
    MoreMenu1.Caption = "&More..."
DIM MoreMenu2 AS QMenuItem
    MoreMenu2.Caption = "&More..."
DIM MoreMenu3 AS QMenuItem
    MoreMenu3.Caption = "&More..."
DIM MoreMenu4 AS QMenuItem
    MoreMenu4.Caption = "&More..."
DIM MoreMenu5 AS QMenuItem
    MoreMenu5.Caption = "&More..."
DIM MoreMenu6 AS QMenuItem
    MoreMenu6.Caption = "&More..."
DIM MoreMenu7 AS QMenuItem
    MoreMenu7.Caption = "&More..."

DIM TexturesMenu(256) AS QMENUITEM
FOR CONTADOR=0 TO 255
      TexturesMenu(CONTADOR).Caption = "Texture " + STR$(CONTADOR+1)
      TexturesMenu(CONTADOR).OnClick = ShowTexture7
      IF CONTADOR<224 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture6
      IF CONTADOR<192 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture5
      IF CONTADOR<160 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture4
      IF CONTADOR<128 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture3
      IF CONTADOR<96 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture2
      IF CONTADOR<64 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture1
      IF CONTADOR<32 THEN TexturesMenu(CONTADOR).OnClick = ShowTexture
NEXT CONTADOR
    
CREATE Form1 AS QForm
    IcoHandle = ICO_CARN
    Height = 300
    Width = 450
    BorderStyle = 2
    Caption="Carnivores 2/Ice Age Textures Viewer -  (C) 2003 by M.A.Ch.F."
CREATE MainMenu AS QMainMenu
    AddItems FileMenu, ShowMenu
END CREATE    
CREATE Canvas AS QCanvas
    Visible = False
    OnPaint = CanvasPaint
    OnMouseMove=CanvasMouseMove
END CREATE
    Center
  ShowModal
END CREATE

SUB ShowTexture (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex
    DrawTexture(Indice)
END SUB

SUB ShowTexture1 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+32
    DrawTexture(Indice)
END SUB

SUB ShowTexture2 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+64
    DrawTexture(Indice)
END SUB

SUB ShowTexture3 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+96
    DrawTexture(Indice)
END SUB

SUB ShowTexture4 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+128
    DrawTexture(Indice)
END SUB

SUB ShowTexture5 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+160
    DrawTexture(Indice)
END SUB

SUB ShowTexture6 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+192
    DrawTexture(Indice)
END SUB

SUB ShowTexture7 (Sender AS QMENUITEM)
    Indice=Sender.MenuIndex+224
    DrawTexture(Indice)
END SUB

SUB DrawTexture (Z AS INTEGER)
DIM Destination AS QRECT
DIM Source AS QRECT
Canvas.Visible = False

Form1.Color = 0

WITH Destination
.Left = 0
.Right = 128
.Top = 0
.Bottom = 128
END WITH
WITH Source
.Left = 0
.Right = 128
.Top = 128*Z
.Bottom = .Top + 128
END WITH
Bitmap.CopyRect(Destination, TextureList, Source)
Form1.Caption="Tex"+STR$(Z+1)+"/"+STR$(A1&)

Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True
Form1.ShowModal

END SUB
 

SUB CanvasMouseMove (X AS INTEGER, Y AS INTEGER)
    Canvas.Hint=""
    Canvas.Hint=STR$(X)+","+STR$(Y)
END SUB      

SUB CanvasPaint
    W = Canvas.ClientWidth
    H = Canvas.ClientHeight
    Canvas.FillRect(0, 0, W, H, 0)

    CREATE RectArea as QRect
     Top=0
     Left=0
     Right=W
     Bottom=H
    END CREATE
    Canvas.Draw(0,0, Bitmap.BMP)
END SUB

SUB FileOpen
  DIM OpenDialog AS QOpenDialog

  OpenDialog.InitialDir = CurDir$
  OpenDialog.Filter = "RSC Files (*.rsc)|*.rsc|All Files (*.*)|*.*"

  IF OpenDialog.Execute THEN
    FileName$=OpenDialog.FileName
    Form1.Caption="Viewing "+FileName$
    LoadMapFile
'    ShowMenu.Enabled=True
      END IF
END SUB

     


SUB ExitClick
  Form1.Close
END SUB  


SUB LoadMapFile

ShowMenu.Enabled=False
FOR CONTADOR=MoreMenu7.Count TO 1 STEP -1
MoreMenu7.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu6.Count TO 1 STEP -1
MoreMenu6.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu5.Count TO 1 STEP -1
MoreMenu5.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu4.Count TO 1 STEP -1
MoreMenu4.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu3.Count TO 1 STEP -1
MoreMenu3.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu2.Count TO 1 STEP -1
MoreMenu2.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=MoreMenu1.Count TO 1 STEP -1
MoreMenu1.DelIndex(CONTADOR-1)
NEXT CONTADOR
FOR CONTADOR=ShowMenu.Count TO 1 STEP -1
ShowMenu.DelIndex(CONTADOR-1)
NEXT CONTADOR

DIM File AS QFileStream
File.Open(FileName$, fnOpenRead)
'IF File.Size=&H220000 THEN
Form1.Caption="Reading Header Data..."
Form1.Show
File.Read(A1&)
File.Read(B1&)
File.Read(C1&)
File.Read(D1&)
File.Read(E1&)
File.Read(F1&)
File.Read(G1&)
File.Read(H1&)

File.Read(I1&)
File.Read(J1&)
File.Read(K1&)
File.Read(L1&)

File.Read(M1&)
File.Read(N1&)
File.Read(O1&)
File.Read(P1&)

File.Read(Q1&)
File.Read(R1&)
File.Read(S1&)
File.Read(T1&)

Form1.ClientWidth = 128
Form1.ClientHeight = 128
Canvas.Width = 128
Canvas.Height = 128
Canvas.ClientWidth = 128
Canvas.ClientHeight = 128
BitMap.Width = 128
BitMap.Height = 128
Form1.Center
TextureList.Height = 128*A1&
FOR CONTADOR=1 TO A1&
File.LoadArray(TEX??(0, 0),128*128)
'InitScreen
StoreBitmap(CONTADOR-1)
IF CONTADOR<=32 THEN
ShowMenu.AddItems(TexturesMenu(CONTADOR-1))
ELSE
 IF CONTADOR=33 THEN ShowMenu.AddItems(MoreMenu1)
 IF CONTADOR<=64 THEN
 MoreMenu1.AddItems(TexturesMenu(CONTADOR-1))
 ELSE
  IF CONTADOR=65 THEN MoreMenu1.AddItems(MoreMenu2)
  IF CONTADOR<=96 THEN
  MoreMenu2.AddItems(TexturesMenu(CONTADOR-1))
  ELSE
   IF CONTADOR=97 THEN MoreMenu2.AddItems(MoreMenu3)
   IF CONTADOR<=128 THEN
   MoreMenu3.AddItems(TexturesMenu(CONTADOR-1))
   ELSE
    IF CONTADOR=129 THEN MoreMenu3.AddItems(MoreMenu4)
    IF CONTADOR<=160 THEN
    MoreMenu4.AddItems(TexturesMenu(CONTADOR-1))
    ELSE
     IF CONTADOR=161 THEN MoreMenu4.AddItems(MoreMenu5)
     IF CONTADOR<=192 THEN
     MoreMenu5.AddItems(TexturesMenu(CONTADOR-1))
     ELSE
      IF CONTADOR=192 THEN MoreMenu5.AddItems(MoreMenu6)
      IF CONTADOR<=224 THEN
      MoreMenu6.AddItems(TexturesMenu(CONTADOR-1))
      ELSE
       IF CONTADOR=225 THEN MoreMenu6.AddItems(MoreMenu7)
       MoreMenu7.AddItems(TexturesMenu(CONTADOR-1))
      END IF
     END IF
    END IF
   END IF
  END IF
 END IF
END IF
Form1.Caption="Tex"+STR$(CONTADOR)+"/"+STR$(A1&)
Form1.Show
NEXT CONTADOR
ShowMenu.Enabled=True
'ELSE
'Form1.Caption="Not a valid Carnivores .map file!"
'Form1.Show
'END IF    
File.Close
DrawTexture(0)

END SUB

SUB StoreBitmap (Z AS INTEGER)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

H = Y: V = X + 128*Z
H1 = Y + 1: V1 = X + 1 + 128*Z
TextureList.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)


NEXT Y: NEXT X


END SUB

SUB InitScreen

Canvas.Visible = False

Form1.Color = 0

DrawPicture555
Canvas.Visible = True
Canvas.Repaint
Canvas.ShowHint=True

END SUB


SUB DrawPicture555


'BitMap.FillRect(0, 0, 128, 128, 0)

FOR X = 0 TO 127
FOR Y = 0 TO 127

R = TEX??(X, Y)

D=R

ROJO=INT((D AND &H7C00)/&H400)
VERDE=(INT(D AND &H03E0)/&H20)
AZUL=INT(D AND &H001F)

D=(AZUL*&H80000+VERDE*&H800+ROJO*8)

H = Y: V = X
H1 = Y + 1: V1 = X + 1
BitMap.Rectangle(H, V, H1, V1, D)
'BitMap.Pset(H, V, D)


NEXT Y: NEXT X


END SUB



